package ru.landgrafhomyak.serdha.api.v0.ddl

public interface ModuleTemplate<ModuleUserExtension : Any> {
	public fun <NewModuleUserExtension : Any> modify(
		newVersionKey: String,
		updater: (oldModule: ModuleTemplate<ModuleUserExtension>, rootNs: Namespace, updater: ModuleModifyingRound) -> NewModuleUserExtension
	): ModuleTemplate<NewModuleUserExtension>

	public val versionKey: String
}