package ru.landgrafhomyak.serdha.api.v0.runtime

import ru.landgrafhomyak.serdha.api.v0.ddl.ModuleModifyingRound
import ru.landgrafhomyak.serdha.api.v0.ddl.ModuleTemplate
import ru.landgrafhomyak.serdha.api.v0.ddl.Namespace

@Suppress("SpellCheckingInspection")
public interface UnsynchronizedDatabase {
	public fun <ModuleUserExtension : Any> createModule(initialVersionKey: String, content: (rootNs: Namespace, updater: ModuleModifyingRound) -> ModuleUserExtension): ModuleTemplate<ModuleUserExtension>

	public suspend fun <ModuleUserExtension : Any> synchronize(conent: ModuleTemplate<ModuleUserExtension>): SynchronizedDatabase<ModuleUserExtension>
}